export class Listdetails extends HTMLElement {
  constructor() {
    super();
    const shadowRoot = this.attachShadow({ mode: "open" });
    const template = document.createElement("template");
    template.innerHTML = `<style>

    /* ".inherited-styles-for-exported-element" is a generated class for the inherited styles of the exported element, feel free to rename it. */

    * {
      box-sizing: border-box;
    }
    
    section {
      display: block;
      position: relative;
    }
    
    ::-webkit-input-placeholder {
      color: inherit;
      opacity: .54;
    }
    
    ::-webkit-file-upload-button {
      appearance: button;
      font-family: inherit;
      font-size: inherit;
      font-weight: inherit;
      line-height: inherit;
    }
    
    section>* {
      position: relative;
    }
    
    h1 {
      color: inherit;
      font-family: Roboto, sans-serif;
      font-size: 2.25rem;
      line-height: 1.2;
    }
    
    h1, p {
      padding: 0;
    }
    
    .u-section-1 {
      min-height: 522px;
    }
    
    @media (max-width: 1199px) {
      .u-section-1 {
        min-height: 429px;
      }
    }
    
    @media (max-width: 991px) {
      .u-section-1 {
        min-height: 329px;
      }
    }
    
    @media (max-width: 767px) {
      .u-section-1 {
        min-height: 511px;
      }
    }
    
    @media (max-width: 575px) {
      .u-section-1 {
        min-height: 359px;
      }
    }
    
    .u-btn, .u-text-default {
      align-self: flex-start;
      display: table;
    }
    
    .u-btn {
      border: 0 none transparent;
      cursor: pointer;
      font-family: inherit;
      font-style: initial;
      font-weight: inherit;
      line-height: inherit;
      outline: 0;
      text-align: center;
      text-decoration: none;
      user-select: none;
      vertical-align: middle;
      white-space: nowrap;
    }
    
    .u-text-default {
      width: fit-content;
    }
    
    .u-image {
      background-repeat: no-repeat;
      background-size: cover;
      object-fit: cover;
      vertical-align: middle;
    }
    
    .u-container-layout {
      flex: 1 1 0;
      max-width: 100%;
      position: relative;
      transition-duration: inherit;
      -ms-overflow-style: none; /* IE and Edge */
      scrollbar-width: none; /* Firefox */
    }

    .u-conainer-layout::-webkit-scrollbar {
      display: none;
    }
    
    .u-container-layout>* {
      position: relative;
    }
    
    .u-valign-middle {
      display: flex;
      flex-direction: column;
    }
    
    .u-valign-middle>* {
      flex-shrink: 0;
    }
    
    .u-valign-middle {
      justify-content: center;
    }
    
    .u-layout-row {
      display: flex;
      flex: 1 1 auto;
    }
    
    .u-layout-row>* {
      max-height: 100%;
    }
    
    .u-layout-row {
      flex-direction: row;
      flex-wrap: wrap;
      max-width: 100%;
      min-height: fit-content;
    }
    
    .u-layout-cell {
      background-clip: padding-box;
      background-origin: padding-box;
      display: flex;
      position: relative;
      overflow-y: auto;
      max-height: 100vh;
      -ms-overflow-style: none; /* IE and Edge */
      scrollbar-width: none; /* Firefox */
    }

    .u-layout-cell::-webkit-scrollbar {
      display: none;
    }
    
    .u-group {
      display: flex;
    }
    
    .inherited-styles-for-exported-element {
      color: #111;
      font-family: "Open Sans", sans-serif;
      font-size: 1rem;
      line-height: 1.6;
    }
    
    .u-align-center {
      text-align: center;
    }
    
    .u-text {
      overflow-wrap: break-word;
    }
    
    .u-grey-5, .u-image {
      color: #111;
    }
    
    .u-grey-5 {
      background-color: #f2f2f2;
    }
    
    a:hover {
      outline: 0;
    }
    
    .u-clearfix::after {
      clear: both;
      content: "";
      display: table;
    }
    
    h1:not(.u-title) {
      font-size: 3rem;
      font-weight: 400;
      line-height: 1.1;
    }
    
    h1:not(.u-title), p:not(.u-text-variant) {
      margin-bottom: 20px;
      margin-top: 20px;
    }
    
    @media (max-width: 575px) {
      h1:not(.u-title) {
        font-size: 1.875rem;
      }
    }
    
    .u-section-1 .u-layout-wrap-1 {
      margin-bottom: 0;
      margin-top: 0;
    }
        
    .u-section-1 .u-container-layout-1 {
      padding: 0;
    }
    
    .u-section-1 .u-layout-cell-2 {
      min-height: 522px;
    }
    
    .u-section-1 .u-container-layout-2 {
      padding: 0;
    }
    
    .u-section-1 .u-group-1 {
      height: 100vh;
      margin-bottom: 0;
      margin-top: 0;
      min-height: 522px;
    }
    
    .u-section-1 .u-container-layout-3 {
      padding: 30px 50px;
      overflow-y: auto;
    }
    
    .u-section-1 .u-text-1 {
      font-weight: 700;
      margin: 0 auto;
    }
    
    .u-section-1 .u-text-2 {
      font-size: 1.25rem;
      font-weight: 300;
      margin: 20px 0 0;
    }
    
    .u-section-1 .u-btn-1 {
      background-image: none;
      font-size: 1.125rem;
      height: 50px;
      letter-spacing: 2px;
      margin: 30px auto 0;
      padding: 11px 24px 11px 23px;
      text-transform: uppercase;
    }
    
    @media (max-width: 1199px) {
    
      .u-section-1 .u-image-1,   .u-section-1 .u-layout-cell-2 {
        min-height: 100vh;
      }
    
      .u-section-1 .u-group-1 {
        min-height: 100vh;
      }
    }
    
    @media (max-width: 991px) {
      .u-section-1 .u-image-1 {
        min-height: 100vh;
      }
    
      .u-section-1 .u-layout-cell-2 {
        min-height: 100vh;
      }
    
      .u-section-1 .u-container-layout-3 {
        padding-left: 30px;
        padding-right: 30px;
      }
    }
    
    @media (max-width: 767px) {
      .u-section-1 .u-image-1 {
        min-height: 411px;
      }
    
      .u-section-1 .u-container-layout-3 {
        padding-left: 10px;
        padding-right: 10px;
      }
    }
    
    @media (max-width: 575px) {
      .u-section-1 .u-image-1 {
        min-height: 259px;
      }
    }
    
    .u-btn:hover {
      text-decoration: none;
    }
    
    .u-btn:active {
      background-image: none;
      outline: 0;
    }
    
    .u-text-default:empty {
      display: block;
      width: 15px;
    }
    
    .u-layout-row>.u-size-36 {
      flex: 0 0 60%;
      max-width: 60%;
      min-width: 60%;
    }
    
    .u-layout-row>.u-size-24 {
      flex: 0 0 40%;
      max-width: 40%;
      min-width: 40%;
      height: 100vh;
    }
    
    .u-group .u-container-layout>* {
      position: relative;
    }
    
    .u-container-style:not([class*=u-align-]) {
      text-align: left;
    }
    
    .u-btn:focus {
      outline: 5px auto -webkit-focus-ring-color;
      outline-offset: -2px;
    }
    
    .u-layout-cell.u-image:not(.u-hover-box) {
     
    }
    
    @media (min-width: 576px) and (max-width: 767px) {
      .u-layout-wrap:not(.u-layout-custom-sm) .u-layout-row>* {
        min-width: 100%;
      }
    }
    
    @media (max-width: 575px) {
      .u-layout-wrap:not(.u-layout-custom-xs) .u-layout-row>* {
        min-width: 100%;
      }
    }
    
    .u-expanded-width {
      margin-left: 0 !important;
      margin-right: 0 !important;
      width: 100% !important;
    }
    
    .u-radius-50 {
      border-radius: 50px !important;
    }
    
    .u-button-style.u-palette-2-base {
      background-color: #db545a !important;
      color: #fff !important;
    }
    
    @media (min-width: 576px) and (max-width: 767px) {
      .u-layout-wrap:not(.u-layout-custom-sm) .u-layout {
        margin-left: 0 !important;
        margin-right: 0 !important;
      }
    }
    
    @media (max-width: 575px) {
      .u-layout-wrap:not(.u-layout-custom-xs) .u-layout {
        margin-left: 0 !important;
        margin-right: 0 !important;
      }
    }
    
    .u-button-style.u-palette-2-base:hover {
      background-color: #d63b42 !important;
      color: #fff !important;
    }
    
    @media (min-width: 576px) and (max-width: 767px) {
      .u-layout-wrap:not(.u-layout-custom-sm) .u-layout .u-layout-cell {
        border-left-color: initial !important;
        border-left-style: initial !important;
        border-left-width: 0 !important;
        border-right-color: initial !important;
        border-right-style: initial !important;
        border-right-width: 0 !important;
      }
    }
    
    @media (max-width: 575px) {
      .u-layout-wrap:not(.u-layout-custom-xs) .u-layout .u-layout-cell {
        border-left-color: initial !important;
        border-left-style: initial !important;
        border-left-width: 0 !important;
        border-right-color: initial !important;
        border-right-style: initial !important;
        border-right-width: 0 !important;
      }
    }
    
    ::slotted(img) {
      min-width: 100%;
      max-width: 100%;
      object-fit: contain;
      margin: 0;
      padding: 0;
      overflow-y: auto;
      -ms-overflow-style: none; /* IE and Edge */
      scrollbar-width: none; /* Firefox */
    }
    
    ::slotted(a) {
     text-decoration: none;
     color: white;
    }
    </style>
      
    <section class="u-clearfix u-section-1" id="sec-b580">
    <div class="u-clearfix u-expanded-width u-layout-wrap u-layout-wrap-1">
      <div class="u-layout">
        <div class="u-layout-row">
          <div class="u-container-style u-image u-layout-cell u-size-36 u-image-1">
            <div class="u-container-layout u-container-layout-1"><slot name="image"></slot></div>
          </div>
          <div class="u-container-style u-layout-cell u-size-24 u-layout-cell-2">
            <div class="u-container-layout u-container-layout-2">
              <div class="u-align-center u-container-style u-expanded-width u-grey-5 u-group u-group-1">
                <div class="u-container-layout u-valign-middle u-container-layout-3">
                  <h1 class="u-text u-text-default u-text-1"><slot name="title"></slot></h1>
                  <p class="u-text u-text-2"><slot name="paragraph"></slot></p>
                  <a href="" class="u-btn u-btn-round u-button-style u-color-scheme-summer-time u-color-style-multicolor-1 u-palette-2-base u-radius-50 u-btn-1"><slot name="link"></slot></a>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>`;
    shadowRoot.appendChild(template.content.cloneNode(true));
  }

  render(html) {
    this.innerHTML = ``;
    this.innerHTML = `${html}`;
  }

  connectedCallback() {
    console.log("Connected!");
    console.log(this.innerHTML);
    const childNodes = this.childNodes;
    const htmlArray = [];

    // Iterate over the nodes in the NamedNodeMap
    for (let i = 0; i < childNodes.length; i++) {
      const node = childNodes[i];
      if (node.nodeName === "#text") continue;
      const attributesArray = [];
      [...node.attributes].forEach((attr) => {
        const nodeName = attr.nodeName;
        const nodeValue = attr.nodeValue;
        attributesArray.push({ [nodeName]: nodeValue });
      });

      const slot = attributesArray.find((el) =>
        el.hasOwnProperty("slot")
      )?.slot;
      const field = attributesArray.find((el) =>
        el.hasOwnProperty("field")
      )?.field;
      const src = attributesArray.find((el) => el.hasOwnProperty("src"))?.src;
      const nodeClass = attributesArray.find((el) =>
        el.hasOwnProperty("class")
      )?.class;
      const nodeId = attributesArray.find((el) => el.hasOwnProperty("id"))?.id;
      const href = attributesArray.find((el) =>
        el.hasOwnProperty("href")
      )?.href;

      let htmlString = "";

      if (field) {
        if (node.localName === "img") {
          htmlString = `<${node.localName} slot="${slot}" field="${field}" src="{{${field}}}">`;
        } else if (node.localName === "input") {
          htmlString = "";
        } else {
          htmlString = `<${node.localName} slot="${slot}" field="${field}">{{${field}}}</${node.localName}>`;
        }
      }

      if (!field) {
        if (node.localName === "img") {
          htmlString = `<${node.localName} slot="${slot}" src="${src}">`;
        } else if (node.localName === "input") {
          htmlString = "";
        } else {
          htmlString = `<${node.localName} slot="${slot}">${node.innerHTML}</${node.localName}>`;
        }
      }

      htmlArray.push({
        tag: node.localName,
        value: node.nodeValue,
        innerText: node.innerText,
        parentElement: node.parentElement.tagName,
        innerHTML: node.innerHTML,
        attributes: attributesArray,
        field: field,
        slot: slot,
        src: src,
        class: nodeClass,
        id: nodeId,
        href: href,
        htmlString: htmlString,
      });
    }
    console.log(htmlArray);

    const componentAttributes = [];
    [...this.attributes].forEach((attr) => {
      componentAttributes.push({ [attr.nodeName]: attr.nodeValue });
    });
    const base = componentAttributes.find((el) =>
      el.hasOwnProperty("base")
    )?.base;
    const table = componentAttributes.find((el) =>
      el.hasOwnProperty("table")
    )?.table;
    const recordId = componentAttributes.find((el) =>
      el.hasOwnProperty("record")
    )?.record;

    const softrAppId = "bf2d5ce0-21e1-47d5-814b-ce1be7c5e668";
    htmlArray.unshift({
      componentName: this.tagName,
      componentAttributes: componentAttributes,
      softrAppId: softrAppId,
    });

    let elementsString = "";

    htmlArray.forEach((el) => {
      if (el.htmlString) {
        elementsString
          ? (elementsString = elementsString + ", " + el.htmlString)
          : (elementsString = el.htmlString);
      }
    });

    const elements = elementsString.split(", ");

    let fieldsString = "";

    htmlArray.forEach((el) => {
      if (el.componentName) return;
      const fieldValue = el.field ? el.field : "none";

      fieldsString
        ? (fieldsString = fieldsString + ", " + fieldValue)
        : (fieldsString = fieldValue);
    });

    const fields = fieldsString.split(", ");

    let tagsString = "";

    htmlArray.forEach((el) => {
      tagsString
        ? (tagsString = tagsString + ", " + el.tag)
        : (tagsString = el.tag);
    });

    const tags = tagsString.split(", ");

    const string = JSON.stringify(this.innerHTML);
    console.log(string);

    function findUniqueSubstrings(string, substringFormat) {
      const substrings = [];
      let startIndex = 0;
      while (startIndex < string.length) {
        const start = string.indexOf(substringFormat, startIndex);
        if (start === -1) {
          break;
        }
        let end = start + substringFormat.length;
        while (string[end] !== "}") {
          end++;
        }
        end++; // include the closing curly brace
        end++; // include the closing curly brace
        substrings.push(string.substring(start, end));
        startIndex = end;
      }
      return [...new Set(substrings)];
    }

    const placeholders = findUniqueSubstrings(string, "{{");

    const payload = {
      softrAppId: softrAppId,
      base: base,
      table: table,
      recordId: recordId,
      elements: elements,
      fields: fields,
      tags: tags,
      innerHTML: this.innerHTML,
      placeholders: placeholders,
    };
    console.log(payload);
    this.render(``);

    const payloadString = JSON.stringify(payload);
    const component = `{"component":${payloadString}}`;
    console.log(component);
    const apiURL = `https://xtsq-tb6s-h4xj.f2.xano.io/api:V1kisAip/no-code-render`;

    fetch(apiURL, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
      },
      body: component,
    })
      .then((response) => response.json())
      .then((data) => {
        this.render(data);
      });
  }
}

/* TESTING THE LAMBDA

let inputString = "";

const elementsArray = [`<p slot="content" field="name">{{name}}</p>`];
const record = { name: "Jamie" };
const fieldsArray = [`name`];
const tagsArray = ["p"];

for (let i = 0; i < elementsArray.length; i++) {
  const element = elementsArray[i];
  const field = fieldsArray[i];
  if (field === "none") {
    inputString = inputString + element;
    continue;
  }
  const tag = tagsArray[i];
  const value = tag === "img" ? record[field][0].url : record[field];
  const updatedElement = element.replace(`{{${field}}}`, value);
  inputString = inputString + updatedElement;
}

const decode = function (s) {
  return unescape(encodeURIComponent(s));
};

const html = decode(inputString);

console.log(html);
*/
